package com.galaxis.wms.utils;

import org.springframework.http.HttpCookie;
import org.springframework.http.HttpHeaders;
import org.springframework.http.server.reactive.ServerHttpRequest;
import org.springframework.http.server.reactive.ServerHttpRequestDecorator;
import org.springframework.lang.NonNull;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.server.ServerWebExchange;

import java.util.ArrayList;

/**
 * 作者：lizw <br/>
 * 创建时间：2020/07/06 17:44 <br/>
 */
public class ExchangeUtils {
    /**
     * 为了能重写Cookies包装原始ServerHttpRequest
     */
    public static ServerWebExchange modifyRequestHeaders(ServerWebExchange exchange, ServerHttpRequest serverHttpRequest) {
        final HttpHeaders headers = new HttpHeaders();
        serverHttpRequest.getHeaders().forEach((name, values) -> headers.put(name, new ArrayList<>(values)));
        final MultiValueMap<String, HttpCookie> cookies = new LinkedMultiValueMap<>(serverHttpRequest.getCookies().size());
        cookies.addAll(serverHttpRequest.getCookies());
        ServerHttpRequest newRequest = new ServerHttpRequestDecorator(serverHttpRequest) {
            @NonNull
            @Override
            public HttpHeaders getHeaders() {
                return headers;
            }

            @NonNull
            @Override
            public MultiValueMap<String, HttpCookie> getCookies() {
                return cookies;
            }
        };
        return exchange.mutate().request(newRequest).build();
    }
}
